package com.kisawo.android.test.DrawBitmapOrientationTest;

import android.content.Context;
import android.util.AttributeSet;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Matrix;
import java.util.Random;

public class DrawBitmapTestLandFakeView extends SurfaceView implements Runnable, SurfaceHolder.Callback {
	private Thread mainLoopThread; 
	private SurfaceHolder holder;
	private Bitmap mBitmap;
	private int mScreenWidth, mScreenHeight;
	private int mCharWidth, mCharHeight;
	private Random mRand;
	public DrawBitmapTestLandFakeView(Context context, AttributeSet attrs) {
		super(context, attrs);
		// TODO ꂽRXgN^[EX^u
		mBitmap = BitmapFactory.decodeResource( getResources(), R.drawable.droid );
		mCharWidth = mBitmap.getWidth();
		mCharHeight = mBitmap.getHeight();
		holder = getHolder(); 
        holder.addCallback( this ); 
        holder.setFixedSize( getWidth(), getHeight() );
	}
	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {
		// TODO ꂽ\bhEX^u
		mScreenWidth = w;
		mScreenHeight = h;
	    mainLoopThread = new Thread(this); 
	    mainLoopThread.start(); 
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		// TODO ꂽ\bhEX^u
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO ꂽ\bhEX^u
		mainLoopThread = null;
	}

	@Override
	public void run() {
		// TODO ꂽ\bhEX^u
		Canvas canvas;
		Paint paint;
		paint = new Paint( Paint.ANTI_ALIAS_FLAG );
		paint.setTextSize( 40 );
		paint.setColor( Color.RED );
		long time = System.currentTimeMillis();
		mRand = new Random( time );
		Matrix matrix = new Matrix();
		matrix.postRotate( 90, 0, 0 );
    	for( int i=0; i<100; i++ ){
    		canvas = holder.lockCanvas();
    		int x = mRand.nextInt( mScreenWidth-mCharHeight )+mCharHeight;
    		int y = mRand.nextInt( mScreenHeight-mCharWidth );
    		Matrix mat = new Matrix( matrix );
    		mat.postTranslate( x, y );
    		canvas.drawBitmap( mBitmap, mat, paint );
    		holder.unlockCanvasAndPost(canvas);
    	}
    	time = System.currentTimeMillis()-time;
   		canvas = holder.lockCanvas();
		canvas.drawText( String.valueOf(100f*1000f/time)+" fps", 0, 40, paint );
		holder.unlockCanvasAndPost(canvas);
	}

}
